<?php
# +------------------------------------------------------------------+
# |             ____ _               _        __  __ _  __           |
# |            / ___| |__   ___  ___| | __   |  \/  | |/ /           |
# |           | |   | '_ \ / _ \/ __| |/ /   | |\/| | ' /            |
# |           | |___| | | |  __/ (__|   <    | |  | | . \            |
# |            \____|_| |_|\___|\___|_|\_\___|_|  |_|_|\_\           |
# |                                                                  |
# | Copyright Mathias Kettner 2012             mk@mathias-kettner.de |
# +------------------------------------------------------------------+
#
# This file is part of Check_MK.
# The official homepage is at http://mathias-kettner.de/check_mk.
#
# check_mk is free software;  you can redistribute it and/or modify it
# under the  terms of the  GNU General Public License  as published by
# the Free Software Foundation in version 2.  check_mk is  distributed
# in the hope that it will be useful, but WITHOUT ANY WARRANTY;  with-
# out even the implied warranty of  MERCHANTABILITY  or  FITNESS FOR A
# PARTICULAR PURPOSE. See the  GNU General Public License for more de-
# ails.  You should have  received  a copy of the  GNU  General Public
# License along with GNU Make; see the file  COPYING.  If  not,  write
# to the Free Software Foundation, Inc., 51 Franklin St,  Fifth Floor,
# Boston, MA 02110-1301 USA.

// new version of diskstat

if(!strncmp($servicedesc, 'EVAPerf_Host_port_statistics', strlen('EVAPerf_Host_port_statistics')) || !strncmp($servicedesc, 'EVAPerf_Physical_disk_groups', strlen('EVAPerf_Physical_disk_groups')) )

{
    // Make data sources available via names
    $RRD = array();
    foreach ($NAME as $i => $n) {
        $RRD[$n] = "$RRDFILE[$i]:$DS[$i]:MAX";
        $WARN[$n] = $WARN[$i];
        $CRIT[$n] = $CRIT[$i];
        $MIN[$n]  = $MIN[$i];
        $MAX[$n]  = $MAX[$i];
    }

    $parts = explode("_", $servicedesc);
    $disk = $parts[2];

    $parts = explode(' ', $NAGIOS_SERVICEPERFDATA);
    list($varname_read, $values) = explode('=', $parts[0] );
    list($varname_write, $values) = explode('=', $parts[1] );

    if(strpos($NAGIOS_SERVICEPERFDATA, 'MBs'))
    {
	$opt[1] = "--vertical-label 'Throughput (MB/s)' -X0  --title \"Disk throughput $hostname / Data\" ";
	$def[1] = "HRULE:0#a0a0a0 ".
	# read
                  "DEF:read=$RRD[$varname_read] ".
                  "CDEF:read_mb=read,1,/ ".
                  "AREA:read_mb#40c080:\"Read \" ".
                  "GPRINT:read_mb:LAST:\"%8.1lf MB/s last\" ".
                  "GPRINT:read_mb:AVERAGE:\"%6.1lf MB/s avg\" ".
                  "GPRINT:read_mb:MAX:\"%6.1lf MB/s max\\n\" ";

	# write
	$def[1] .=
                  "DEF:write=$RRD[$varname_write] ".
                  "CDEF:write_mb=write,1,/ ".
                  "CDEF:write_mb_neg=write_mb,-1,* ".
                  "AREA:write_mb_neg#4080c0:\"Write  \"  ".
                  "GPRINT:write_mb:LAST:\"%6.1lf MB/s last\" ".
                  "GPRINT:write_mb:AVERAGE:\"%6.1lf MB/s avg\" ".
                  "GPRINT:write_mb:MAX:\"%6.1lf MB/s max\\n\" ";
    }
    else if(strpos($NAGIOS_SERVICEPERFDATA, 'Latency'))
    {
	$opt[1] = "--vertical-label 'Throughput (ms)' -X0  --title \"Disk throughput $hostname / Latency\" ";
	$def[1] = "HRULE:0#a0a0a0 ".
	# read
                  "DEF:read=$RRD[$varname_read] ".
                  "CDEF:read_mb=read,1,/ ".
                  "AREA:read_mb#40c080:\"Read \" ".
                  "GPRINT:read_mb:LAST:\"%8.1lf ms last\" ".
                  "GPRINT:read_mb:AVERAGE:\"%6.1lf ms avg\" ".
                  "GPRINT:read_mb:MAX:\"%6.1lf ms max\\n\" ";

	# write
	$def[1] .=
                  "DEF:write=$RRD[$varname_write] ".
                  "CDEF:write_mb=write,1,/ ".
                  "CDEF:write_mb_neg=write_mb,-1,* ".
                  "AREA:write_mb_neg#4080c0:\"Write  \"  ".
                  "GPRINT:write_mb:LAST:\"%6.1lf ms last\" ".
                  "GPRINT:write_mb:AVERAGE:\"%6.1lf ms avg\" ".
                  "GPRINT:write_mb:MAX:\"%6.1lf ms max\\n\" ";
    }
    else if(strpos($NAGIOS_SERVICEPERFDATA, 'Reqs'))
    {
	$opt[1] = "--vertical-label 'Throughput (Req/s)' -X0  --title \"Disk throughput $hostname / IO\" ";
	$def[1] = "HRULE:0#a0a0a0 ".
	# read
                  "DEF:read=$RRD[$varname_read] ".
                  "CDEF:read_mb=read,1,/ ".
                  "AREA:read_mb#40c080:\"Read \" ".
                  "GPRINT:read_mb:LAST:\"%8.1lf Req/s last\" ".
                  "GPRINT:read_mb:AVERAGE:\"%6.1lf Req/s avg\" ".
                  "GPRINT:read_mb:MAX:\"%6.1lf Req/s max\\n\" ";

	# write
	$def[1] .=
                  "DEF:write=$RRD[$varname_write] ".
                  "CDEF:write_mb=write,1,/ ".
                  "CDEF:write_mb_neg=write_mb,-1,* ".
                  "AREA:write_mb_neg#4080c0:\"Write  \"  ".
                  "GPRINT:write_mb:LAST:\"%6.1lf Req/s last\" ".
                  "GPRINT:write_mb:AVERAGE:\"%6.1lf Req/s avg\" ".
                  "GPRINT:write_mb:MAX:\"%6.1lf Req/s max\\n\" ";
    }
}
else if(!strncmp($servicedesc, 'EVAPerf_Array_controller_status', strlen('EVAPerf_Array_controller_status')) )
{
    $opt[1] = "--vertical-label 'Controller status %' -l0  -u 100 --title \"Controller status\" ";
    $def[1] =  "DEF:util=$RRDFILE[1]:$DS[1]:MAX ".
               "CDEF:ok=util,$WARN[1],MIN ".
               "CDEF:warn=util,$CRIT[1],MIN ".
               "AREA:util#c0f020 ".
               "AREA:warn#90f020 ".
               "AREA:ok#60f020:\"Utilization\:\" ".
               "LINE:util#40a018 ".
               "GPRINT:util:LAST:\"%.0lf%%,\" ".
               "GPRINT:util:MIN:\"min\: %.0lf%%,\" ".
               "GPRINT:util:MAX:\"max\: %.0lf%%\" ".
               "HRULE:$WARN[1]#ffe000:\"Warning at $WARN[1]%\" ".
               "HRULE:$CRIT[1]#ff0000:\"Critical at $CRIT[1]%\\n\" ".
               "";
}
else if(!strncmp($servicedesc, 'EVAPerf_Array_status', strlen('EVAPerf_Array_status')) )
{
    if(strpos($NAGIOS_SERVICEPERFDATA, 'MBs'))
    {
	$opt[1] = "--vertical-label 'Throughput (MB/s)' -X0  --title \"Disk throughput $hostname / Data\" ";
	$def[1] = "HRULE:0#a0a0a0 ".
                  "DEF:read=$RRDFILE[1]:$DS[1]:MAX ".
                  "CDEF:read_mb=read,1,/ ".
                  "AREA:read_mb#40c080:\"Read/Write \" ".
                  "GPRINT:read_mb:LAST:\"%8.1lf MB/s last\" ".
                  "GPRINT:read_mb:AVERAGE:\"%6.1lf MB/s avg\" ".
                  "GPRINT:read_mb:MAX:\"%6.1lf MB/s max\\n\" ";
    }
    if(strpos($NAGIOS_SERVICEPERFDATA, 'Reqs'))
    {
	$opt[1] = "--vertical-label 'Throughput (Req/s)' -X0  --title \"Disk throughput $hostname / IO\" ";
	$def[1] = "HRULE:0#a0a0a0 ".
                  "DEF:read=$RRDFILE[1]:$DS[1]:MAX ".
                  "CDEF:read_mb=read,1,/ ".
                  "AREA:read_mb#40c080:\"Read/Write \" ".
                  "GPRINT:read_mb:LAST:\"%8.1lf Req/s last\" ".
                  "GPRINT:read_mb:AVERAGE:\"%6.1lf Req/s avg\" ".
                  "GPRINT:read_mb:MAX:\"%6.1lf Req/s max\\n\" ";
    }
}
else {
    $opt[1] = "--vertical-label 'Througput (MByte/s)' -l0  -u 1 --title \"Disk throughput $hostname / $servicedesc\" ";
    $def[1]  = "DEF:kb=$RRDFILE[1]:$DS[1]:AVERAGE " ;
    $def[1] .= "CDEF:mb=kb,1024,/ " ;
    $def[1] .= "AREA:mb#40c080 " ;
    $def[1] .= "GPRINT:mb:LAST:\"%6.1lf MByte/s last\" " ;
    $def[1] .= "GPRINT:mb:AVERAGE:\"%6.1lf MByte/s avg\" " ;
    $def[1] .= "GPRINT:mb:MAX:\"%6.1lf MByte/s max\\n\" ";
    }
?>

