######################################################
#
# Sebastian Mehl        sebastian.mehl@ltv.sachsen.de
#
######################################################
def perfometer_check_EVAPerf(row, check_command, perf_data):
#	return repr(check_command), ''
	color = "#8888EE"
	service = perf_data[0][0]
	sdata = float(perf_data[0][1])
	if service.startswith('CPU_Controler') or service.startswith('DATA_Controler'):
	    h = '<table><tr>'
	    varname, value, unit, warn, crit, minn, maxx = perf_data[0]
	    perc_used = 100 * (float(value) / float(maxx))
	    perc_free = 100 - float(perc_used)
	    color = { 0: "#0f8", 1: "#ff2", 2: "#f22", 3: "#fa2" }[row["service_state"]]
	    h += perfometer_td(perc_used, color)
	    h += perfometer_td(perc_free, "white")
	    h += "</tr></table>"
	    return "%d%%" % perc_used, h
	elif service.startswith('Total_Host_Reqs'):
	    return sdata, perfometer_logarithmic(sdata, 4000, 2, color)
	elif service.startswith('Total_Host_MBs'):
	    return sdata, perfometer_logarithmic(sdata, 300, 2, color)
	elif service.startswith('HostPort_Latency') or service.startswith('PhysicalDiskGroups_Latency'):
	    if len(perf_data) < 2:
	        return "", ""
	    read_latency = float(perf_data[0][1])
	    write_latency = float(perf_data[1][1])
	    text = "%-.2fms  %-.2fms" % (read_latency, write_latency)
	    return text, perfometer_logarithmic_dual(read_latency, "#60e0a0", write_latency, "#60a0e0", 20, 2)
	elif service.startswith('HostPort_MBs') or service.startswith('PhysicalDiskGroups_MBs'):
	    if len(perf_data) < 2:
	        return "", ""
	    read_mbs = float(perf_data[0][1])
	    write_mbs = float(perf_data[1][1])
	    text = "%-.2fMB/s  %-.2fMB/s" % (read_mbs, write_mbs)
	    return text, perfometer_logarithmic_dual(read_mbs, "#60e0a0", write_mbs, "#60a0e0", 40, 2)
	elif service.startswith('HostPort_Reqs') or service.startswith('PhysicalDiskGroups_Reqs'):
	    if len(perf_data) < 2:
	        return "", ""
	    read_reqs = float(perf_data[0][1])
	    write_reqs = float(perf_data[1][1])
	    text = "%-.2fReq/s  %-.2fReq/s" % (read_reqs, write_reqs)
	    return text, perfometer_logarithmic_dual(read_reqs, "#60e0a0", write_reqs, "#60a0e0", 1000, 2)
	return '',''
	
perfometers["check_mk-EVAPerf"] = perfometer_check_EVAPerf
